/*
 * Copyright (c) 2014 Claus Assmann
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the license/LICENSE.3C file which can be found at the
 * top level of this source code distribution.
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-misc-0.c,v 1.2 2014/02/14 01:33:17 ca Exp $")

#include "sm/assert.h"
#include "sm/heap.h"
#include "sm/test.h"

#include <stdio.h>

static void
testempty(void)
{
	char *s0;
	char buf[8];

	s0 = NULL;
	SM_TEST(SM_IS_EMPTY_S(s0));
	buf[0] = '\0';
	SM_TEST(SM_IS_EMPTY_S(buf));
	s0 = buf;
	SM_TEST(SM_IS_EMPTY_S(s0));

	buf[0] = '0';
	buf[1] = '\0';
	SM_TEST(!SM_IS_EMPTY_S(buf));
	SM_TEST(!SM_IS_EMPTY_S(s0));
}

int
main(int argc, char **argv)
{
	int c;

	while ((c = getopt(argc, argv, "V")) != -1)
	{
		switch (c)
		{
		  default:
			break;
		}
	}
	sm_test_begin(argc, argv, "test misc-0");
	argc -= optind;
	argv += optind;

	testempty();

	return sm_test_end();
}
