#!/bin/sh
# $Id: t-clt-se-tmo-0.sh,v 1.3 2014/01/17 04:32:30 ca Exp $
#
# ----------------------------------------
# test SMTP session timeout (from client)
# ----------------------------------------
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

cd ../qmgr || exit 1

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

rm -f ${MT} ${ALI}
# create aliases
${CAT} > ${ALI} <<EOF
user:	local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}

# ----------------------------------------
# don't log if no transaction active
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
if ${SHELL} ${SD}/smtp1.sh -Z smtpc2 -Ss@local.host -Ruser@local.host -Ruser@local.host -1 -E 1 -A 1 -X 1 -0 -c "-W n=6 -d 6" -n 1 -T 2 -V "-O 2" -v 9
then
  if grep ' status=read_error, ' ${SSL} >/dev/null
  then
    echo "$0: found read_error in ${SSL}"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  ERRS=`expr ${ERRS} + 1 `
fi
fi

# ----------------------------------------
# log even though no transaction active because there wasn't one yet
TEST=2
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
if ${SHELL} ${SD}/smtp1.sh -Z smtpc2 -Ss@local.host -Ruser@local.host -Ruser@local.host -1 -E 0 -A 0 -X 0 -0 -c "-W m=6 -d 6" -n 1 -T 2 -V "-O 2" -v 9
then
  if grep ' status=read_error, ' ${SSL} >/dev/null
  then
    :
  else
    echo "$0: did not find read_error in ${SSL}"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
  ERRS=`expr ${ERRS} + 1 `
fi
fi

test ${ERRS} -eq 0 && exit 0
echo "${ERRS} error(s)"
exit 1
