#!/bin/sh
# $Id: t-iqdb-0.sh,v 1.9 2011/10/19 19:54:16 ca Exp $
#
# ----------------------------------------
# test IQDB overflows
# uses smtp1.sh
# ----------------------------------------
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to right directory (where the programs will be executed).
cd ../qmgr || exit 1
rm -f ${MTMAP}

chkqlog()
{
  for p in 'IQDB usage *= *0 ' 'IQDB current *= *0$' 'IBDB open TAs   =0$' 'IBDB open RCPTs =0$'
  do
     if grep "$p" q0.log >/dev/null
     then
       :
     else
       echo "$0: test ${TEST} failed: missing $p in q0.log"
       return 1
     fi
  done
  return 0
}

TEST=1
# ----------------------------------------
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
if ./qmgr -VVV 2>/dev/null | ${GREP} QMGR_TEST >/dev/null
then
if ${SHELL} ${SD}/smtp1.sh -Q"-I 1" -X 0 -E 0 -A 0 -S"s@local.host" -R"r@local.host" "$@"
then
    ${VERBOSE} && echo "test ${TEST} succeeded"
else
    echo "$0: test ${TEST} failed"
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  echo "SKIPPED: $0: test $TEST: qmgr not compiled with QMGR_TEST"
fi
fi

TEST=2
# ----------------------------------------
# no mail is being sent because IQDB "overflows" right after all rcpts are in
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
NI=33
R=""
i=0
while test $i -lt $NI
do
  R="$R -Rr$i@local.host"
  i=`expr $i + 1 `
done

if ${SHELL} ${SD}/smtp1.sh -1 -Q"-I $NI" -A 0 -E 0 -X 0 -S"s@local.host" $R -z q "$@"
then
  if chkqlog
  then
    ${VERBOSE} && echo "test ${TEST} succeeded"
  else
    echo "$0: test ${TEST} failed"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
    echo "$0: test ${TEST} failed"
    ERRS=`expr ${ERRS} + 1 `
fi
test $ERRS -ge 1 -a X"${MTA_STOPONERROR}" != X && exit 1
fi

TEST=3
# ----------------------------------------
# no mail is being sent because IQDB "overflows" after all but one rcpt are in
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
NI=33
R=""
i=0
while test $i -le $NI
do
  R="$R -Rr$i@local.host"
  i=`expr $i + 1 `
done

if ${SHELL} ${SD}/smtp1.sh -1 -Q"-I $NI" -A 0 -E 0 -X 0 -S"s@local.host" $R -z q "$@"
then
  if chkqlog
  then
    ${VERBOSE} && echo "test ${TEST} succeeded"
  else
    echo "$0: test ${TEST} failed"
    ERRS=`expr ${ERRS} + 1 `
  fi
else
    echo "$0: test ${TEST} failed"
    ERRS=`expr ${ERRS} + 1 `
    test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
