/*
 * Copyright (c) 2005 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: base64.h,v 1.4 2011/01/08 20:03:44 ca Exp $
 */

#ifndef SM_BASE64_H
#define SM_BASE64_H 1

#include "sm/generic.h"

/* characters for base 64 print/scan (change last two chars?) */
#define SM_B64DIGS "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!_"
#define SM_B64MIN	' '
#define SM_B64MAX	'z'

/* map SM_B64MIN to SM_B64MAX for base 64 */
#define SM_B64DIGS2VAL {	\
	-1, 62, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,	\
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, -1, -1, -1, -1, -1, -1, -1,	\
	10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, \
	27, 28, 29, 30, 31, 32, 33, 34, 35,	\
	-1, -1, -1, -1, 63, -1,	\
	36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, \
	53, 54, 55, 56, 57, 58, 59, 60, 61	\
	}

int sm_base64_decode(const uchar *_str, uchar *_buf, size_t _buflen);
int sm_base64_encode(const uchar *_data, size_t _datalen, uchar *_buf, size_t _buflen);

#endif /* SM_BASE64_H */
