/*
 * Copyright (c) 2005, 2011 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 * $Id: common.h,v 1.14 2013/12/07 03:06:15 ca Exp $
 */

/*
**  Common definitions for MTA modules
*/

#ifndef SM_COMMON_H
#define SM_COMMON_H 1

/* Defaults for compile time options.  */
/* pmilter, smtps */
#ifndef MTA_USE_PMILTER
# define MTA_USE_PMILTER	0
#endif

/* pmilter, smtpc, smtps (smtps used to define this to 2 by default!) */
#ifndef MTA_USE_RSAD
# define MTA_USE_RSAD	2		/* RCPT status after final dot  */
#endif

/* smtpc */
#ifndef SC_PIPELINING
# define SC_PIPELINING	1
#endif

#ifndef SC_STATS
# define SC_STATS	1
#endif

#ifndef SC_DEBUG
# define SC_DEBUG	0
#endif

/* Compile time options for QMGR. */
#ifndef MTA_DELAYED_DSN
# define MTA_DELAYED_DSN	1	/* code not fully tested! */
#endif

#ifndef QMGR_DEBUG
# define QMGR_DEBUG	1
#endif

#ifndef QMGR_TEST
# define QMGR_TEST	0
#endif

#ifndef AQ_DEBUG
# define AQ_DEBUG	0
#endif

/* Turn off for production */
#ifndef QMGR_STATS
# define QMGR_STATS	0
#endif

/* -V: show configuration data */
#define SM_SV_VERSION	1	/* version of module */
#define SM_SV_LIBS		2	/* library versions */
#define SM_SV_OPTIONS	3	/* compile time options */
#define SM_SV_RD_CONF	4	/* configuration data as read from conf file */
#define SM_SV_DFLT_CONF	5	/* default configuration data */
#define SM_SV_ALL_CONF	6	/* all configuration data */

#define SM_SHOW_VERSION(level)		((level) >= SM_SV_VERSION)
#define SM_SHOW_LIBS(level)	\
	((level) >= SM_SV_LIBS && (level) < SM_SV_RD_CONF)
#define SM_SHOW_OPTIONS(level)	\
	((level) >= SM_SV_OPTIONS && (level) < SM_SV_RD_CONF)
#define SM_SHOW_RD_CONF(level)		((level) == SM_SV_RD_CONF)
#define SM_SHOW_DFLT_CONF(level)	((level) == SM_SV_DFLT_CONF)
#define SM_SHOW_ALL_CONF(level)	((level) == SM_SV_ALL_CONF)


#define SM_DONTRUNASROOT  "sev=FATAL, prg=%s, status=do not run as root!"

/* limit for total number of A records (currently compile time only) */
#ifndef SM_DNS_A_MAX
# define SM_DNS_A_MAX	100
#endif

/*
 *  This is the maximum smtpc id value that should be generated by mcp.
 *  It therefore applies also to other process "ids".
 *  XREF: SMTPC_STID_FORMAT
 */

#define PROC_ID_MAX	255	/* maximum process id value, 8 bit */

#endif /* SM_COMMON_H */
