/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-tr_simple.c,v 1.3 2010/10/03 14:36:02 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/string.h"
#include "sm/test.h"
#include "sm/misc.h"
#include "sm/io.h"

static int Verbosity = 0;

static void
test_tr(char *str, const char *repl, const char *with, const char *out)
{
	size_t l;
	char s[256];

	l = strlcpy(s, str, sizeof(s));
	SM_TEST_E(l < sizeof(s));
	tr_simple(s, repl, with);
	SM_TEST(strcmp(s, out) == 0);

  error:
	return;
}

static void
testf(void)
{

	test_tr("abc", "a", "b", "bbc");
	test_tr("abc", "ab", "XY", "XYc");
	test_tr("abcdef", "bXf", "BxF", "aBcdeF");
	test_tr("abcdef", "xyz", "XYZ", "abcdef");
	test_tr("abcdef", "fac", "XYZ", "YbZdeX");
	test_tr("ab_cCLdef", "_CL", " \r\n", "ab c\r\ndef");

	return;
}

int
main(int argc, char *argv[])
{
	int c;

	while ((c = getopt(argc, argv, "V")) != -1) {
		switch (c) {
		  case 'V':
			++Verbosity;
			break;
		}
	}
	sm_test_begin(argc, argv, "test tr_simple");
	argc -= optind;
	argv += optind;
	testf();
	return sm_test_end();
}
