#!/bin/sh
# $Id: t-exit-1.sh,v 1.13 2013/12/23 00:10:21 ca Exp $
# Copyright (c) 2004 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test restart: restart program up to maxfails (4)
# Note: 4 (maxfails) and 69 (EX_UNAVAILABLE) are hardcoded in this script
# ----------------------------------------
#

CONF=exit.conf
CNTF=exit.cnt
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
. ${SD}/common.sh


rm -f ${PIDS} ${OUT} ${CNTF}
echo 0 > ${CNTF}
cat > ${CONF} <<EOF
exit {
	start_action = wait;
	processes_min = 1;
	processes_max = 1;
	user = ${USER};
	path = ./t-exit;
	arguments = "t-exit -f ${CNTF} -s 1 -e 69";
}
EOF
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}
sleep 10
CNT=4
chkr ${CNTF} ${CNT}
C=`grep 'mcp: start=exit' ${OUT} | wc -l`
if test ${C} -ne ${CNT}
then
  ${VERBOSE} && echo "wrong number of restarts: $C in ${OUT}"
  ERRS=`expr ${ERRS} + 1 `
fi

stopit

exit ${ERRS}
